// auto-generated DO NOT EDIT

#pragma once

#include <algorithm>
#include <array>
#include <functional>
#include <mutex>
#include <rclcpp/node.hpp>
#include <rclcpp_lifecycle/lifecycle_node.hpp>
#include <set>
#include <sstream>
#include <string>
#include <type_traits>
#include <vector>

#include <fmt/core.h>
#include <fmt/format.h>
#include <fmt/ranges.h>

#include <parameter_traits/parameter_traits.hpp>

#include <rsl/static_string.hpp>
#include <rsl/static_vector.hpp>
#include <rsl/parameter_validators.hpp>



namespace gripper_action_controller {

// Use validators from RSL
using rsl::unique;
using rsl::subset_of;
using rsl::fixed_size;
using rsl::size_gt;
using rsl::size_lt;
using rsl::not_empty;
using rsl::element_bounds;
using rsl::lower_element_bounds;
using rsl::upper_element_bounds;
using rsl::bounds;
using rsl::upper_bounds;
using rsl::lower_bounds;
using rsl::lt;
using rsl::gt;
using rsl::lt_eq;
using rsl::gt_eq;
using rsl::one_of;
using rsl::to_parameter_result_msg;

// temporarily needed for backwards compatibility for custom validators
using namespace parameter_traits;

template <typename T>
[[nodiscard]] auto to_parameter_value(T value) {
    return rclcpp::ParameterValue(value);
}

template <size_t capacity>
[[nodiscard]] auto to_parameter_value(rsl::StaticString<capacity> const& value) {
    return rclcpp::ParameterValue(rsl::to_string(value));
}

template <typename T, size_t capacity>
[[nodiscard]] auto to_parameter_value(rsl::StaticVector<T, capacity> const& value) {
    return rclcpp::ParameterValue(rsl::to_vector(value));
}
    struct Params {
        double action_monitor_rate = 20.0;
        std::string joint = "";
        double goal_tolerance = 0.01;
        double max_effort = 0.0;
        bool allow_stalling = false;
        double stall_velocity_threshold = 0.001;
        double stall_timeout = 1.0;
        // for detecting if the parameter struct has been updated
        rclcpp::Time __stamp;
    };
    struct StackParams {
        double action_monitor_rate = 20.0;
        double goal_tolerance = 0.01;
        double max_effort = 0.0;
        bool allow_stalling = false;
        double stall_velocity_threshold = 0.001;
        double stall_timeout = 1.0;
    };

  class ParamListener{
  public:
    // throws rclcpp::exceptions::InvalidParameterValueException on initialization if invalid parameter are loaded
    ParamListener(rclcpp::Node::SharedPtr node, std::string const& prefix = "")
    : ParamListener(node->get_node_parameters_interface(), prefix) {}

    ParamListener(rclcpp_lifecycle::LifecycleNode::SharedPtr node, std::string const& prefix = "")
    : ParamListener(node->get_node_parameters_interface(), prefix) {}

    ParamListener(const std::shared_ptr<rclcpp::node_interfaces::NodeParametersInterface>& parameters_interface, std::string const& prefix = ""){
      prefix_ = prefix;
      if (!prefix_.empty() && prefix_.back() != '.') {
        prefix_ += ".";
      }

      parameters_interface_ = parameters_interface;
      declare_params();
      auto update_param_cb = [this](const std::vector<rclcpp::Parameter> &parameters){return this->update(parameters);};
      handle_ = parameters_interface_->add_on_set_parameters_callback(update_param_cb);
      clock_ = rclcpp::Clock();
    }

    Params get_params() const{
      std::lock_guard<std::mutex> lock(mutex_);
      return params_;
    }

    bool is_old(Params const& other) const {
      std::lock_guard<std::mutex> lock(mutex_);
      return params_.__stamp != other.__stamp;
    }

    StackParams get_stack_params() {
      Params params = get_params();
      StackParams output;
      output.action_monitor_rate = params.action_monitor_rate;
      output.goal_tolerance = params.goal_tolerance;
      output.max_effort = params.max_effort;
      output.allow_stalling = params.allow_stalling;
      output.stall_velocity_threshold = params.stall_velocity_threshold;
      output.stall_timeout = params.stall_timeout;

      return output;
    }

    void refresh_dynamic_parameters() {
      auto updated_params = get_params();
      // TODO remove any destroyed dynamic parameters

      // declare any new dynamic parameters
      rclcpp::Parameter param;

    }

    rcl_interfaces::msg::SetParametersResult update(const std::vector<rclcpp::Parameter> &parameters) {
      auto updated_params = get_params();

      for (const auto &param: parameters) {
        if (param.get_name() == (prefix_ + "action_monitor_rate")) {
            if(auto validation_result = lower_bounds(param, 0.1);
              !validation_result) {
                return rsl::to_parameter_result_msg(validation_result);
            }
            updated_params.action_monitor_rate = param.as_double();
        }
        if (param.get_name() == (prefix_ + "joint")) {
            updated_params.joint = param.as_string();
        }
        if (param.get_name() == (prefix_ + "goal_tolerance")) {
            if(auto validation_result = lower_bounds(param, 0.0);
              !validation_result) {
                return rsl::to_parameter_result_msg(validation_result);
            }
            updated_params.goal_tolerance = param.as_double();
        }
        if (param.get_name() == (prefix_ + "max_effort")) {
            if(auto validation_result = lower_bounds(param, 0.0);
              !validation_result) {
                return rsl::to_parameter_result_msg(validation_result);
            }
            updated_params.max_effort = param.as_double();
        }
        if (param.get_name() == (prefix_ + "allow_stalling")) {
            updated_params.allow_stalling = param.as_bool();
        }
        if (param.get_name() == (prefix_ + "stall_velocity_threshold")) {
            updated_params.stall_velocity_threshold = param.as_double();
        }
        if (param.get_name() == (prefix_ + "stall_timeout")) {
            updated_params.stall_timeout = param.as_double();
        }
      }

      updated_params.__stamp = clock_.now();
      update_interal_params(updated_params);
      return rsl::to_parameter_result_msg({});
    }

    void declare_params(){
      auto updated_params = get_params();
      // declare all parameters and give default values to non-required ones
      if (!parameters_interface_->has_parameter(prefix_ + "action_monitor_rate")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Hz";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.action_monitor_rate);
          parameters_interface_->declare_parameter(prefix_ + "action_monitor_rate", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "joint")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.joint);
          parameters_interface_->declare_parameter(prefix_ + "joint", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "goal_tolerance")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.goal_tolerance);
          parameters_interface_->declare_parameter(prefix_ + "goal_tolerance", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "max_effort")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Max allowable effort";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.max_effort);
          parameters_interface_->declare_parameter(prefix_ + "max_effort", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "allow_stalling")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Allow stalling will make the action server return success if the gripper stalls when moving to the goal";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.allow_stalling);
          parameters_interface_->declare_parameter(prefix_ + "allow_stalling", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "stall_velocity_threshold")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "stall velocity threshold";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.stall_velocity_threshold);
          parameters_interface_->declare_parameter(prefix_ + "stall_velocity_threshold", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "stall_timeout")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "stall timeout";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.stall_timeout);
          parameters_interface_->declare_parameter(prefix_ + "stall_timeout", parameter, descriptor);
      }
      // get parameters and fill struct fields
      rclcpp::Parameter param;
      param = parameters_interface_->get_parameter(prefix_ + "action_monitor_rate");
      if(auto validation_result = lower_bounds(param, 0.1);
        !validation_result) {
          throw rclcpp::exceptions::InvalidParameterValueException(fmt::format("Invalid value set during initialization for parameter 'action_monitor_rate': " + validation_result.error()));
      }
      updated_params.action_monitor_rate = param.as_double();
      param = parameters_interface_->get_parameter(prefix_ + "joint");
      updated_params.joint = param.as_string();
      param = parameters_interface_->get_parameter(prefix_ + "goal_tolerance");
      if(auto validation_result = lower_bounds(param, 0.0);
        !validation_result) {
          throw rclcpp::exceptions::InvalidParameterValueException(fmt::format("Invalid value set during initialization for parameter 'goal_tolerance': " + validation_result.error()));
      }
      updated_params.goal_tolerance = param.as_double();
      param = parameters_interface_->get_parameter(prefix_ + "max_effort");
      if(auto validation_result = lower_bounds(param, 0.0);
        !validation_result) {
          throw rclcpp::exceptions::InvalidParameterValueException(fmt::format("Invalid value set during initialization for parameter 'max_effort': " + validation_result.error()));
      }
      updated_params.max_effort = param.as_double();
      param = parameters_interface_->get_parameter(prefix_ + "allow_stalling");
      updated_params.allow_stalling = param.as_bool();
      param = parameters_interface_->get_parameter(prefix_ + "stall_velocity_threshold");
      updated_params.stall_velocity_threshold = param.as_double();
      param = parameters_interface_->get_parameter(prefix_ + "stall_timeout");
      updated_params.stall_timeout = param.as_double();


      updated_params.__stamp = clock_.now();
      update_interal_params(updated_params);
    }

    private:
      void update_interal_params(Params updated_params) {
        std::lock_guard<std::mutex> lock(mutex_);
        params_ = updated_params;
      }

      std::string prefix_;
      Params params_;
      rclcpp::Clock clock_;
      std::shared_ptr<rclcpp::node_interfaces::OnSetParametersCallbackHandle> handle_;
      std::shared_ptr<rclcpp::node_interfaces::NodeParametersInterface> parameters_interface_;
      std::mutex mutable mutex_;
  };

} // namespace gripper_action_controller